diff --git a/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java b/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
index c1ebf91fb..cb1cac4ae 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
@@ -427,43 +434,38 @@ public class ScreenPaged
     public void renderBackground() {
         super.renderBackground();
 
-        if (mc.currentWorld == null)
-        {
-            Tessellator tessellator = Tessellator.instance;
-            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+        if (this.mc.currentWorld == null) {
+            final @NotNull Tessellator tessellator = Tessellator.instance;
+            this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            float scale = 32F;
+            final float scale = 32F;
             tessellator.startDrawingQuads();
             tessellator.setColorOpaque_I(0x202020);
 
-            tessellator.addVertexWithUV(0, bottom, 0.0D, 0, (float)(bottom + (int) rightScrollAmount) / scale);
-            tessellator.addVertexWithUV(width, bottom, 0.0D, (float)width / scale, (float)(bottom + (int) rightScrollAmount) / scale);
-            tessellator.addVertexWithUV(width, top, 0.0D, (float)width / scale, (float)(top + (int) rightScrollAmount) / scale);
-            tessellator.addVertexWithUV(0, top, 0.0D, 0, (float)(top + (int) rightScrollAmount) / scale);
+            tessellator.addVertexWithUV(0, this.bottom, 0.0D, 0, (float) (this.bottom + (int) this.rightScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.width, this.bottom, 0.0D, (float) this.width / scale, (float) (this.bottom + (int) this.rightScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.width, this.top, 0.0D, (float) this.width / scale, (float) (this.top + (int) this.rightScrollAmount) / scale);
+            tessellator.addVertexWithUV(0, this.top, 0.0D, 0, (float) (this.top + (int) this.rightScrollAmount) / scale);
 
-            tessellator.addVertexWithUV(0, bottom, 0.0D, 0, (float)(bottom + (int) leftScrollAmount) / scale);
-            tessellator.addVertexWithUV(leftWidth, bottom, 0.0D, (float) leftWidth / scale, (float)(bottom + (int) leftScrollAmount) / scale);
-            tessellator.addVertexWithUV(leftWidth, top, 0.0D, (float) leftWidth / scale, (float)(top + (int) leftScrollAmount) / scale);
-            tessellator.addVertexWithUV(0, top, 0.0D, 0, (float)(top + (int) leftScrollAmount) / scale);
+            tessellator.addVertexWithUV(0, this.bottom, 0.0D, 0, (float) (this.bottom + (int) this.leftScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.leftWidth, this.bottom, 0.0D, (float) this.leftWidth / scale, (float) (this.bottom + (int) this.leftScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.leftWidth, this.top, 0.0D, (float) this.leftWidth / scale, (float) (this.top + (int) this.leftScrollAmount) / scale);
+            tessellator.addVertexWithUV(0, this.top, 0.0D, 0, (float) (this.top + (int) this.leftScrollAmount) / scale);
 
             tessellator.draw();
-        }
-        else
-        {
-            drawRect(0, 0, width, top, 0x5F000000);
-            drawRect(0, bottom, width, height, 0x5F000000);
-            drawRect(leftWidth, top, leftWidth + SEPARATOR_WIDTH, bottom, 0x5F000000);
+        } else {
+            this.drawRect(0, 0, this.width, this.top, 0x5F000000);
+            this.drawRect(0, this.bottom, this.width, this.height, 0x5F000000);
+            this.drawRect(this.leftWidth, this.top, this.leftWidth + SEPARATOR_WIDTH, this.bottom, 0x5F000000);
         }
     }
 
-    private void overlayBackground(int minX, int maxX, int minY, int maxY)
-    {
-        if (mc.currentWorld == null)
-        {
-            Tessellator tessellator = Tessellator.instance;
-            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+    private void overlayBackground(final int minX, final int maxX, final int minY, final int maxY) {
+        if (this.mc.currentWorld == null) {
+            final @NotNull Tessellator tessellator = Tessellator.instance;
+            this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            float scale = 32F;
+            final float scale = 32F;
             tessellator.startDrawingQuads();
             tessellator.setColorOpaque_I(0x404040);
             tessellator.addVertexWithUV(minX, maxY, 0.0D, (float) minX / scale, (float) maxY / scale);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/ButtonComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/ButtonComponent.java
index ba0d2afed..a2e461450 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/ButtonComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/ButtonComponent.java
@@ -3,30 +3,29 @@ package net.minecraft.client.gui.popup;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.core.lang.I18n;
+import org.jetbrains.annotations.NotNull;
 
 public class ButtonComponent
     extends InteractivePopupComponent<Integer> {
-    private final Minecraft minecraft;
-    private final String buttonLabel;
-    private final String[] buttonValues;
-    private final ButtonElement button;
+    private final @NotNull Minecraft minecraft = Minecraft.getMinecraft();
+    private final @NotNull String buttonLabel;
+    private final @NotNull String @NotNull [] buttonValues;
+    private final @NotNull ButtonElement button;
     private int value;
 
-    public ButtonComponent(int width, String buttonLabel, String[] buttonValues, int defaultValue) {
+    public ButtonComponent(final int width, final @NotNull String buttonLabel, final @NotNull String @NotNull [] buttonValues, final int defaultValue) {
         super(width);
 
         this.buttonLabel = buttonLabel;
         this.buttonValues = buttonValues;
 
-        this.minecraft = Minecraft.getMinecraft();
-
         this.value = defaultValue;
 
-        button = new ButtonElement(0, 0, 0, width, getHeight(), getButtonLabel());
+        this.button = new ButtonElement(0, 0, 0, width, this.getHeight(), this.getButtonLabel());
     }
 
-    private String getButtonLabel() {
-        return I18n.getInstance().translateKeyAndFormat(buttonLabel, I18n.getInstance().translateKey(buttonValues[value]));
+    private @NotNull String getButtonLabel() {
+        return I18n.getInstance().translateKeyAndFormat(this.buttonLabel, I18n.getInstance().translateKey(this.buttonValues[this.value]));
     }
 
     @Override
@@ -35,22 +34,22 @@ public class ButtonComponent
     }
 
     @Override
-    public void render(int x, int y, int mouseX, int mouseY) {
-        button.xPosition = x;
-        button.yPosition = y;
-        button.drawButton(minecraft, mouseX, mouseY);
+    public void render(final int x, final int y, final int mouseX, final int mouseY) {
+        this.button.xPosition = x;
+        this.button.yPosition = y;
+        this.button.drawButton(this.minecraft, mouseX, mouseY);
     }
 
     @Override
-    public void onClick(int x, int y, int button) {
-        if (this.button.mouseClicked(minecraft, x, y)) {
-            value = (value + 1) % buttonValues.length;
-            this.button.displayString = getButtonLabel();
+    public void onClick(final int x, final int y, final int button) {
+        if (this.button.mouseClicked(this.minecraft, x, y)) {
+            this.value = (this.value + 1) % this.buttonValues.length;
+            this.button.displayString = this.getButtonLabel();
         }
     }
 
     @Override
-    public Integer getOutput() {
-        return value;
+    public @NotNull Integer getOutput() {
+        return this.value;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/ButtonGroupComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/ButtonGroupComponent.java
index 542085474..108f9e430 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/ButtonGroupComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/ButtonGroupComponent.java
@@ -3,61 +3,53 @@ package net.minecraft.client.gui.popup;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.core.sound.SoundCategory;
+import org.jetbrains.annotations.NotNull;
 
 public class ButtonGroupComponent
-    extends PopupComponent
-{
+    extends PopupComponent {
     private static final int BUTTON_GAP = 2;
-    private final Minecraft minecraft;
-    private final ButtonElement[] buttons;
+    private final @NotNull Minecraft minecraft = Minecraft.getMinecraft();
+    private final @NotNull ButtonElement @NotNull [] buttons;
 
-    public ButtonGroupComponent(int width, String[] buttonLabels, int[] buttonStatusCodes, boolean[] enabled)
-    {
+    public ButtonGroupComponent(final int width, final @NotNull String @NotNull [] buttonLabels, final int @NotNull [] buttonStatusCodes, final boolean @NotNull [] enabled) {
         super(width);
 
-        this.minecraft = Minecraft.getMinecraft();
-
         this.buttons = new ButtonElement[buttonLabels.length];
 
-        int numButtons = this.buttons.length;
+        final int numButtons = this.buttons.length;
         int buttonWidth = (width - (BUTTON_GAP * (numButtons - 1))) / numButtons;
         if (numButtons == 1) buttonWidth = width;
-        buttonWidth = Math.min(buttonWidth,256);
-        for (int i = 0; i < numButtons; i++)
-        {
-            buttons[i] = new ButtonElement(buttonStatusCodes[i], 0, 0, buttonWidth, getHeight(), buttonLabels[i]);
-            buttons[i].enabled = enabled[i];
+        buttonWidth = Math.min(buttonWidth, 256);
+        for (int i = 0; i < numButtons; i++) {
+            this.buttons[i] = new ButtonElement(buttonStatusCodes[i], 0, 0, buttonWidth, this.getHeight(), buttonLabels[i]);
+            this.buttons[i].enabled = enabled[i];
         }
     }
 
     @Override
-    public int getHeight()
-    {
+    public int getHeight() {
         return 20;
     }
 
     @Override
-    public void render(int x, int y, int mouseX, int mouseY)
-    {
-        for (int i = 0; i < buttons.length; i++)
-        {
-            ButtonElement button = buttons[i];
+    public void render(final int x, final int y, final int mouseX, final int mouseY) {
+        for (int i = 0; i < this.buttons.length; i++) {
+            final @NotNull ButtonElement button = this.buttons[i];
 
             button.xPosition = x + (button.width + BUTTON_GAP) * i;
             button.yPosition = y;
-            button.drawButton(minecraft, mouseX, mouseY);
+            button.drawButton(this.minecraft, mouseX, mouseY);
         }
     }
 
     @Override
-    public void onClick(int x, int y, int button)
-    {
-        for (ButtonElement b : buttons)
-        {
-            if (b.mouseClicked(minecraft, x, y))
-            {
-                getParent().close(b.id);
-                minecraft.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+    public void onClick(final int x, final int y, final int button) {
+        for (final @NotNull ButtonElement b : this.buttons) {
+            if (b.mouseClicked(this.minecraft, x, y)) {
+                if (this.getParent() != null) {
+                    this.getParent().close(b.id);
+                }
+                this.minecraft.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
                 return;
             }
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/InteractivePopupComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/InteractivePopupComponent.java
index bd6c8e22b..3c90cb65b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/InteractivePopupComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/InteractivePopupComponent.java
@@ -1,12 +1,14 @@
 package net.minecraft.client.gui.popup;
 
+import org.jetbrains.annotations.NotNull;
+
 public abstract class InteractivePopupComponent<T>
     extends PopupComponent
 {
-    public InteractivePopupComponent(int width)
+    public InteractivePopupComponent(final int width)
     {
         super(width);
     }
 
-    public abstract T getOutput();
+    public abstract @NotNull T getOutput();
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
index 03cf664d0..51724cd09 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
@@ -3,30 +3,29 @@ package net.minecraft.client.gui.popup;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
+import org.jetbrains.annotations.NotNull;
 
 public class LabelComponent
-    extends PopupComponent
-{
-    private final FontRenderer fontRenderer;
-    private final String text;
+    extends PopupComponent {
+    private final @NotNull FontRenderer fontRenderer = Minecraft.getMinecraft().font;
+    private final @NotNull String text;
     private final int color;
 
-    public LabelComponent(final int width, final String text, final int color) {
+    public LabelComponent(final int width, final @NotNull String text, final int color) {
         super(width);
-        this.fontRenderer = Minecraft.getMinecraft().font;
+
         this.text = text;
         this.color = color;
     }
 
     @Override
-    public int getHeight()
-    {
+    public int getHeight() {
         return 12;
     }
 
     @Override
     public void render(final int x, final int y, final int mouseX, final int mouseY) {
-        final int middle = (x - PopupScreen.HORIZONTAL_MARGIN) + getWidth() / 2;
+        final int middle = (x - PopupScreen.HORIZONTAL_MARGIN) + this.getWidth() / 2;
         this.fontRenderer.renderCentered(Tessellator.instance, this.text, middle, y).setShadow().setColor(this.color).call();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/ListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
index 577996205..1a4d1c1ec 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
@@ -3,6 +3,8 @@ package net.minecraft.client.gui.popup;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.sound.SoundCategory;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 
@@ -12,19 +14,18 @@ import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.core.util.helper.MathHelper;
 
 public class ListComponent
-    extends InteractivePopupComponent<Integer>
-{
-    private final Minecraft minecraft;
-    private int selectedItem = 0;
+    extends InteractivePopupComponent<Integer> {
+    private final @NotNull Minecraft minecraft = Minecraft.getMinecraft();
+    private int selectedItem;
     private float scrollAmount = 0;
-    private final ButtonElement[] buttons;
+    private final @NotNull ButtonElement @NotNull [] buttons;
     private final int height;
     private int lastX = 0;
     private int lastY = 0;
     private final boolean closeOnItemSelected;
-    private final TooltipElement tooltip;
-    private final String[] buttonTooltips;
-    
+    private final @NotNull TooltipElement tooltip;
+    private final @NotNull String @Nullable [] buttonTooltips;
+
     private int scrollbarX;
     private int scrollbarY;
     private int scrollbarWidth;
@@ -32,170 +33,154 @@ public class ListComponent
     private boolean isScrolling = false;
     private int clickY;
     private float previousScrollAmount = 0.0f;
-    
-    public ListComponent(int width, int height, String[] buttonLabels, String[] buttonTooltips, int selectedItem, boolean closeOnItemSelected)
-    {
+
+    public ListComponent(
+        final int width,
+        final int height,
+        final @NotNull String @NotNull [] buttonLabels,
+        final @NotNull String @Nullable [] buttonTooltips,
+        final int selectedItem,
+        final boolean closeOnItemSelected
+    ) {
         super(width);
 
-        this.minecraft = Minecraft.getMinecraft();
         this.height = height;
         this.closeOnItemSelected = closeOnItemSelected;
-        this.tooltip = new TooltipElement(minecraft);
+        assert this.minecraft != null;
+        this.tooltip = new TooltipElement(this.minecraft);
 
         this.selectedItem = selectedItem;
         this.buttonTooltips = buttonTooltips;
 
         this.buttons = new ButtonElement[buttonLabels.length];
-        for (int i = 0; i < this.buttons.length; i++)
-        {
+        for (int i = 0; i < this.buttons.length; i++) {
             this.buttons[i] = new ButtonElement(i, 0, 0, width - 2 - 6, 20, buttonLabels[i]);
-            if (i == selectedItem)
-            {
+            if (i == selectedItem) {
                 this.buttons[i].enabled = false;
             }
         }
 
         // Scroll so selected item is in view
-        float ratio = (float)(getScrollableHeight() + this.height) / getScrollableHeight();
-        float sc = (selectedItem / (float)(this.buttons.length - 4)) * ratio;
-        sc -= ((float)this.height / getScrollableHeight());
-        scroll(sc);
+        final float ratio = (float) (this.getScrollableHeight() + this.height) / this.getScrollableHeight();
+        float sc = (selectedItem / (float) (this.buttons.length - 4)) * ratio;
+        sc -= ((float) this.height / this.getScrollableHeight());
+        this.scroll(sc);
     }
 
-    private boolean canScroll()
-    {
-        return getScrollableHeight() > height - 2;
+    private boolean canScroll() {
+        return this.getScrollableHeight() > this.height - 2;
     }
 
     @Override
-    public Integer getOutput()
-    {
+    public @NotNull Integer getOutput() {
         return this.selectedItem;
     }
 
     @Override
-    public int getHeight()
-    {
-        return height;
+    public int getHeight() {
+        return this.height;
     }
 
-    private void scroll(float amount)
-    {
-        if (!canScroll()) {
-            scrollAmount = 0.0f;
+    private void scroll(final float amount) {
+        if (!this.canScroll()) {
+            this.scrollAmount = 0.0f;
         } else {
-            scrollAmount = MathHelper.clamp(scrollAmount + amount, 0.0f, 1.0f);
+            this.scrollAmount = MathHelper.clamp(this.scrollAmount + amount, 0.0f, 1.0f);
         }
     }
 
     @Override
-    public void render(int x, int y, int mouseX, int mouseY)
-    {
+    public void render(final int x, final int y, final int mouseX, final int mouseY) {
         this.lastX = x;
         this.lastY = y;
 
         // Do scroll
-        if (canScroll() && mouseInRegion(x, y, mouseX, mouseY))
-        {
-            float wheel = Mouse.getDWheel();
+        if (this.canScroll() && this.mouseInRegion(x, y, mouseX, mouseY)) {
+            final float wheel = Mouse.getDWheel();
             if (wheel != 0.0f)
-                scroll(wheel / -12.0f);
+                this.scroll(wheel / -12.0f);
         }
 
         GL11.glDisable(GL11.GL_TEXTURE_2D);
-        drawBackground(x, y);
-        drawScrollbar(x, y, mouseX, mouseY);
+        this.drawBackground(x, y);
+        this.drawScrollbar(x, y, mouseY);
 
-        Scissor.enable(x + 1, y + 1, getWidth() - 2, getHeight() - 2);
+        Scissor.enable(x + 1, y + 1, this.getWidth() - 2, this.getHeight() - 2);
         GL11.glEnable(GL11.GL_TEXTURE_2D);
 
         // Draw buttons
-        for (int i = 0; i < buttons.length; i++)
-        {
-            if (canScroll()) {
-                buttons[i].width = getWidth() - 2 - 6;
+        for (int i = 0; i < this.buttons.length; i++) {
+            if (this.canScroll()) {
+                this.buttons[i].width = this.getWidth() - 2 - 6;
             } else {
-                buttons[i].width = getWidth() - 2;
+                this.buttons[i].width = this.getWidth() - 2;
             }
 
-            ButtonElement button = buttons[i];
+            final ButtonElement button = this.buttons[i];
             button.xPosition = x + 1;
-            button.yPosition = (y + 1) + (i * 20) - getScrollPixels();
-            if (mouseInRegion(x, y, mouseX, mouseY))
-            {
-                button.drawButton(minecraft, mouseX, mouseY);
-            }
-            else
-            {
-                button.drawButton(minecraft, -1, -1);
+            button.yPosition = (y + 1) + (i * 20) - this.getScrollPixels();
+            if (this.mouseInRegion(x, y, mouseX, mouseY)) {
+                button.drawButton(this.minecraft, mouseX, mouseY);
+            } else {
+                button.drawButton(this.minecraft, -1, -1);
             }
         }
 
         Scissor.disable();
 
-        if (buttonTooltips != null && mouseInRegion(x, y, mouseX, mouseY))
-        {
-            for (int i = 0; i < buttons.length; i++)
-            {
-                ButtonElement button = buttons[i];
-                if (button.isHovered(mouseX, mouseY))
-                {
-                    tooltip.render(buttonTooltips[i], mouseX, mouseY, 0, 0);
+        if (this.buttonTooltips != null && this.mouseInRegion(x, y, mouseX, mouseY)) {
+            for (int i = 0; i < this.buttons.length; i++) {
+                final ButtonElement button = this.buttons[i];
+                if (button.isHovered(mouseX, mouseY)) {
+                    this.tooltip.render(this.buttonTooltips[i], mouseX, mouseY, 0, 0);
                     break;
                 }
             }
         }
     }
 
-    private boolean mouseInRegion(int x, int y, int mouseX, int mouseY)
-    {
-        return mouseX >= x && mouseX < x + getWidth() && mouseY >= y && mouseY < y + height;
+    private boolean mouseInRegion(final int x, final int y, final int mouseX, final int mouseY) {
+        return mouseX >= x && mouseX < x + this.getWidth() && mouseY >= y && mouseY < y + this.height;
     }
 
-    private int getScrollPixels()
-    {
-        return (int)(scrollAmount * (getScrollableHeight() - (height - 2)));
+    private int getScrollPixels() {
+        return (int) (this.scrollAmount * (this.getScrollableHeight() - (this.height - 2)));
     }
 
-    private int getScrollableHeight()
-    {
-        return 20 * buttons.length;
+    private int getScrollableHeight() {
+        return 20 * this.buttons.length;
     }
 
     @Override
-    public void onClick(int x, int y, int button)
-    {
+    public void onClick(final int x, final int y, final int button) {
         super.onClick(x, y, button);
 
-        int scrollableHeight = getScrollableHeight();
-        int displayRegionHeight = height - 2;
-        boolean canScroll = scrollableHeight > displayRegionHeight;
+        final int scrollableHeight = this.getScrollableHeight();
+        final int displayRegionHeight = this.height - 2;
+        final boolean canScroll = scrollableHeight > displayRegionHeight;
 
-        if(canScroll && button == 0 && x >= scrollbarX && x < scrollbarX + scrollbarWidth && y >= scrollbarY && y < scrollbarY + scrollbarHeight) {
-        	isScrolling = true;
-        	previousScrollAmount = scrollAmount;
-        	clickY = y;
-        	return;
+        if (canScroll && button == 0 && x >= this.scrollbarX && x < this.scrollbarX + this.scrollbarWidth && y >= this.scrollbarY && y < this.scrollbarY + this.scrollbarHeight) {
+            this.isScrolling = true;
+            this.previousScrollAmount = this.scrollAmount;
+            this.clickY = y;
+            return;
         }
-        
-        if (mouseInRegion(lastX, lastY, x, y))
-        {
-            for (ButtonElement b : this.buttons)
-            {
-                if (b.mouseClicked(minecraft, x, y))
-                {
-                    for (ButtonElement b2 : this.buttons)
-                    {
+
+        if (this.mouseInRegion(this.lastX, this.lastY, x, y)) {
+            for (final ButtonElement b : this.buttons) {
+                if (b.mouseClicked(this.minecraft, x, y)) {
+                    for (final ButtonElement b2 : this.buttons) {
                         b2.enabled = true;
                     }
 
                     b.enabled = false;
                     this.selectedItem = b.id;
 
-                    if (closeOnItemSelected)
-                    {
-                        getParent().close(1);
-                        minecraft.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+                    if (this.closeOnItemSelected) {
+                        if (this.getParent() != null) {
+                            this.getParent().close(1);
+                        }
+                        this.minecraft.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
                     }
 
                     break;
@@ -203,76 +188,73 @@ public class ListComponent
             }
         }
     }
-    
+
     @Override
-    public void mouseMovedOrUp(int x, int y, int button)
-    {
-    	super.mouseMovedOrUp(x, y, button);
-    	if(button == 0) {
-    		isScrolling = false;
-    		previousScrollAmount = 0.0f;
-    		clickY = 0;
-    	}
+    public void mouseMovedOrUp(final int x, final int y, final int button) {
+        super.mouseMovedOrUp(x, y, button);
+        if (button == 0) {
+            this.isScrolling = false;
+            this.previousScrollAmount = 0.0f;
+            this.clickY = 0;
+        }
     }
 
-    private void drawBackground(int x, int y)
-    {
-        Tessellator tessellator = Tessellator.instance;
+    private void drawBackground(final int x, final int y) {
+        final @NotNull Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
         tessellator.setColorOpaque_I(0xA0A0A0);
-        tessellator.addVertex(x, y + height, 0.0D);
-        tessellator.addVertex(x + getWidth(), y + height, 0.0D);
-        tessellator.addVertex(x + getWidth(), y, 0.0D);
+        tessellator.addVertex(x, y + this.height, 0.0D);
+        tessellator.addVertex(x + this.getWidth(), y + this.height, 0.0D);
+        tessellator.addVertex(x + this.getWidth(), y, 0.0D);
         tessellator.addVertex(x, y, 0.0D);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setColorOpaque_I(0x000000);
-        tessellator.addVertex(x + 1, y + height - 1, 0.0D);
-        tessellator.addVertex(x + getWidth() - 1, y + height - 1, 0.0D);
-        tessellator.addVertex(x + getWidth() - 1, y + 1, 0.0D);
+        tessellator.addVertex(x + 1, y + this.height - 1, 0.0D);
+        tessellator.addVertex(x + this.getWidth() - 1, y + this.height - 1, 0.0D);
+        tessellator.addVertex(x + this.getWidth() - 1, y + 1, 0.0D);
         tessellator.addVertex(x + 1, y + 1, 0.0D);
         tessellator.draw();
     }
 
-    private void drawScrollbar(int x, int y, int mouseX, int mouseY)
-    {
-    	int scrollableHeight = getScrollableHeight();
-        int displayRegionHeight = height - 2;
+    private void drawScrollbar(final int x, final int y, final int mouseY) {
+        final int scrollableHeight = this.getScrollableHeight();
+        final int displayRegionHeight = this.height - 2;
 
-        if (!canScroll()) {
-        	return;
+        if (!this.canScroll()) {
+            return;
         }
 
-        float scrollbarScale = (float) displayRegionHeight / scrollableHeight;
-        
-    	scrollbarWidth = 6;
-        scrollbarHeight = (int) (scrollbarScale * displayRegionHeight);
-        
-        int minScrollbarY = 0;
-        int maxScrollbarY = displayRegionHeight - scrollbarHeight;
-        
-        int scrollbarDelta = maxScrollbarY - minScrollbarY;
-        
-        scrollbarY = y + 1 + (int) (scrollAmount * scrollbarDelta);
-        scrollbarX = x + getWidth() - 1 - 6;
-        
-        Tessellator t = Tessellator.instance;
+        final float scrollbarScale = (float) displayRegionHeight / scrollableHeight;
+
+        this.scrollbarWidth = 6;
+        this.scrollbarHeight = (int) (scrollbarScale * displayRegionHeight);
+
+        final int minScrollbarY = 0;
+        final int maxScrollbarY = displayRegionHeight - this.scrollbarHeight;
+
+        final int scrollbarDelta = maxScrollbarY - minScrollbarY;
+
+        this.scrollbarY = y + 1 + (int) (this.scrollAmount * scrollbarDelta);
+        this.scrollbarX = x + this.getWidth() - 1 - 6;
+
+        final Tessellator t = Tessellator.instance;
 
         t.startDrawingQuads();
         t.setColorRGBA_I(0x808080, 255);
-        t.drawRectangle(scrollbarX, scrollbarY, 6, scrollbarHeight);
+        t.drawRectangle(this.scrollbarX, this.scrollbarY, 6, this.scrollbarHeight);
         t.setColorRGBA_I(0xc0c0c0, 255);
-        t.drawRectangle(scrollbarX, scrollbarY, 5, scrollbarHeight - 1);
+        t.drawRectangle(this.scrollbarX, this.scrollbarY, 5, this.scrollbarHeight - 1);
         t.draw();
-        
-        if(isScrolling) {
-        	int delta = mouseY - clickY;
-        	float scrolledScreens = delta / (float) scrollbarHeight;
-        	float scrolledPixels = displayRegionHeight * scrolledScreens;
-        	float scrolledAmount = scrolledPixels / (float) (scrollableHeight - displayRegionHeight);
-        	
-        	scrollAmount = MathHelper.clamp(previousScrollAmount + scrolledAmount, 0.0f, 1.0f);
+
+        if (this.isScrolling) {
+            final int delta = mouseY - this.clickY;
+            final float scrolledScreens = delta / (float) this.scrollbarHeight;
+            final float scrolledPixels = displayRegionHeight * scrolledScreens;
+            final float scrolledAmount = scrolledPixels / (float) (scrollableHeight - displayRegionHeight);
+
+            this.scrollAmount = MathHelper.clamp(this.previousScrollAmount + scrolledAmount, 0.0f, 1.0f);
         }
-        
+
     }
 }
